diff --git a/drivers/usb/function/fserial.c b/drivers/usb/function/fserial.c
index dbe342e..b53adc5 100644
--- a/drivers/usb/function/fserial.c
+++ b/drivers/usb/function/fserial.c
@@ -115,13 +115,10 @@ struct userial_context{
 };
 static struct userial_context _context;
 struct device fserial_dev;
+static int cleanup;
 
 /* Functions */
 
-/* module */
-static int __init fs_module_init(void);
-static void __exit fs_module_exit(void);
-
 /* tty driver */
 static int fs_open(struct tty_struct *tty, struct file *file);
 static void fs_close(struct tty_struct *tty, struct file *file);
@@ -145,7 +142,7 @@ static void fs_read_complete(struct usb_endpoint *ep, struct usb_request *req);
 static void fs_write_complete(struct usb_endpoint *ep, struct usb_request *req);
 
 /* gadget driver */
-static void fs_bind(struct usb_endpoint **ept, void *_ctxt);
+static int fs_bind(struct usb_endpoint **ept, void *_ctxt);
 static void fs_unbind(void *_ctxt);
 static int fs_setup( struct usb_ctrlrequest *ctrl, void* buf, int len, void *_ctxt);
 //static void fs_setup_complete(struct usb_endpoint *ep, struct usb_request *req);
@@ -244,9 +241,6 @@ module_param(write_buf_size, uint, S_IRUGO);
 MODULE_PARM_DESC(write_buf_size, "Write buffer size, default=8192");
 
 
-module_init(fs_module_init);
-module_exit(fs_module_exit);
-
 static void fserial_dev_release (struct device *dev) {}
 
 static int fserial_probe (struct platform_device *pdev)
@@ -297,23 +291,18 @@ static DEVICE_ATTR(fserial_enable, 0644, show_fserial_enable, store_fserial_enab
 
 
 /*
-*  fs_module_init
+*  fs_init
 *
 *  Register as a USB gadget driver and a tty driver.
 */
-static int __init fs_module_init(void)
+void fs_init(void)
 {
 	int i;
 	int retval;
-	retval = usb_function_register(&usb_func_userial);
-	if (retval) {
-		printk(KERN_ERR "fs_module_init: cannot register function driver, ret=%d\n", retval);
-		return retval;
-	}
 
 	fs_tty_driver = alloc_tty_driver(FS_NUM_PORTS);
 	if (!fs_tty_driver)
-		return -ENOMEM;
+		goto alloc_tty_driver_fail;
 	fs_tty_driver->owner = THIS_MODULE;
 	fs_tty_driver->driver_name = FS_SHORT_NAME;
 	fs_tty_driver->name = "ttyfs";
@@ -336,36 +325,47 @@ static int __init fs_module_init(void)
 		mutex_init(&fs_open_close_lock[i]);
 
 	retval = tty_register_driver(fs_tty_driver);
-	if (retval) {
-		put_tty_driver(fs_tty_driver);
-		printk(KERN_ERR "fs_module_init: cannot register tty driver, ret=%d\n", retval);
-		return retval;
-	}
+	if (retval)
+		goto tty_register_driver_fail;
 
 	retval = platform_driver_register (&fserial_driver);
 	if (retval < 0)
-		return retval;
+		goto platform_driver_register_fail;
 	retval = platform_device_register (&fserial_device);
 	if (retval < 0)
-		goto err_register_device;
-
-	return 0;
+		goto platform_device_register_fail;
+	retval = usb_function_register(&usb_func_userial);
+	if (retval)
+		goto usb_function_register_fail;
+	cleanup = 1;
+	return;
 
-err_register_device:
+usb_function_register_fail:
+	platform_device_unregister(&fserial_device);
+platform_device_register_fail:
 	platform_driver_unregister(&fserial_driver);
-	return retval;
-
+platform_driver_register_fail:
+	tty_unregister_driver(fs_tty_driver);
+tty_register_driver_fail:
+	put_tty_driver(fs_tty_driver);
+alloc_tty_driver_fail:
+	printk(KERN_ERR "fs_module_init failed\n");
+	return;
 }
 
 /*
-* fs_module_exit
+* fs_exit
 *
 * Unregister as a tty driver.
 */
-static void __exit fs_module_exit(void)
+void fs_exit(void)
 {
-	tty_unregister_driver(fs_tty_driver);
-	put_tty_driver(fs_tty_driver);
+	if (cleanup) {
+		platform_device_unregister (&fserial_device);
+		platform_driver_unregister(&fserial_driver);
+		tty_unregister_driver(fs_tty_driver);
+		put_tty_driver(fs_tty_driver);
+	}
 }
 
 /* TTY Driver */
@@ -1116,7 +1116,7 @@ requeue:
  * Called on module load.  Allocates and initializes the device
  * structure and a control request.
  */
-static void fs_bind(struct usb_endpoint **ept, void *_ctxt)
+static int fs_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 
 	struct userial_context *ctxt = _ctxt;
@@ -1131,9 +1131,7 @@ static void fs_bind(struct usb_endpoint **ept, void *_ctxt)
 	INIT_LIST_HEAD(&ctxt->dev_write_list);
 	INIT_LIST_HEAD(&ctxt->dev_read_list);
 	if (fs_alloc_ports(ctxt, GFP_KERNEL) != 0) {
-		printk(KERN_ERR "fs_bind: cannot allocate ports\n");
-		fs_unbind(ctxt);
-		goto fail;
+		goto fs_alloc_ports_fail;
 	}
 
 	ep = ctxt->dev_out_ep;
@@ -1143,8 +1141,7 @@ static void fs_bind(struct usb_endpoint **ept, void *_ctxt)
 			req->context = ctxt;
 			list_add_tail(&req->list, &ctxt->dev_read_list);
 		} else {
-			printk(KERN_ERR "fs_bind: cannot allocate read requests\n");
-			goto fail;
+			goto dev_read_list_fail;
 		}
 	}
 
@@ -1156,8 +1153,7 @@ static void fs_bind(struct usb_endpoint **ept, void *_ctxt)
 			req->context = ctxt;
 			list_add_tail(&req->list, &ctxt->dev_write_list);
 		} else {
-			printk(KERN_ERR "fs_bind: cannot allocate write requests\n");
-			goto fail;
+			goto dev_write_list_fail;
 		}
 	}
 
@@ -1166,22 +1162,35 @@ static void fs_bind(struct usb_endpoint **ept, void *_ctxt)
 	strcpy(fserial_dev.bus_id, "interface");
 
 	ret = device_register(&fserial_dev);
-	if (ret != 0) {
-		printk(KERN_WARNING "fserial_dev failed to register device: %d\n", ret);
-		goto fail;
-	}
+	if (ret != 0)
+		goto device_register_fail;
 	ret = device_create_file(&fserial_dev, &dev_attr_fserial_enable);
-	if (ret != 0) {
-		printk(KERN_WARNING "fserial_dev device_create_file failed: %d\n", ret);
-		device_unregister(&fserial_dev);
-		goto fail;
-	}
+	if (ret != 0)
+		goto device_create_file_fail;
 	ctxt->registered = 1;
+	return 0;
 
-	return;
-
-fail:
-	printk(KERN_ERR "fs_bind() could not allocate requests\n");
+device_create_file_fail:
+	device_unregister(&fserial_dev);
+device_register_fail:
+dev_write_list_fail:
+	while(!list_empty(&ctxt->dev_write_list)) {
+		req = list_first_entry(&ctxt->dev_write_list,
+			struct usb_request, list);
+		list_del(&req->list);
+		usb_ept_free_req(ctxt->dev_in_ep, req);
+	}
+dev_read_list_fail:
+	while(!list_empty(&ctxt->dev_read_list)) {
+		req = list_first_entry(&ctxt->dev_read_list,
+			struct usb_request, list);
+		list_del(&req->list);
+		usb_ept_free_req(ctxt->dev_out_ep, req);
+	}
+	fs_free_ports(ctxt);
+fs_alloc_ports_fail:
+	printk(KERN_ERR "fs_bind() failed\n");
+	return -1;
 }
 
 /*
@@ -1192,23 +1201,30 @@ fail:
  */
 static void fs_unbind(void *_ctxt)
 {
-	
 	struct userial_context *ctxt = _ctxt;
-	/* read/write requests already freed, only control request remains */
-	if (ctxt != NULL){
-
-		fs_free_ports(ctxt);
-	/*	if (dev->dev_in_ep)
-			usb_ep_disable(dev->dev_in_ep);
-		if (dev->dev_out_ep)
-			usb_ep_disable(dev->dev_out_ep);
-	*/
+	struct usb_request *req;
+
 	if (ctxt->registered)	{
 		device_remove_file(&fserial_dev, &dev_attr_fserial_enable);
 		device_unregister(&fserial_dev);
 		ctxt->registered = 0;
-		}
 	}
+
+	while(!list_empty(&ctxt->dev_write_list)) {
+		req = list_first_entry(&ctxt->dev_write_list,
+			struct usb_request, list);
+		list_del(&req->list);
+		usb_ept_free_req(ctxt->dev_in_ep, req);
+	}
+
+	while(!list_empty(&ctxt->dev_read_list)) {
+		req = list_first_entry(&ctxt->dev_read_list,
+			struct usb_request, list);
+		list_del(&req->list);
+		usb_ept_free_req(ctxt->dev_out_ep, req);
+	}
+
+	fs_free_ports(ctxt);
 }
 
 
@@ -1441,7 +1457,7 @@ static int fs_alloc_ports(struct userial_context *ctxt, gfp_t kmalloc_flags)
 
 	for (i=0; i<FS_NUM_PORTS; i++) {
 		if ((port=kzalloc(sizeof(struct fs_port), kmalloc_flags)) == NULL)
-			return -ENOMEM;
+			goto alloc_port_fail;
 
 		port->port_dev = ctxt;
 		port->port_num = i;
@@ -1456,6 +1472,13 @@ static int fs_alloc_ports(struct userial_context *ctxt, gfp_t kmalloc_flags)
 	}
 
 	return 0;
+
+alloc_port_fail:
+	for (i=0; i<FS_NUM_PORTS; i++) {
+		if (ctxt->dev_port[i] != NULL)
+			kfree(ctxt->dev_port[i]);
+	}
+	return -ENOMEM;
 }
 
 /*
diff --git a/drivers/usb/function/fsync.c b/drivers/usb/function/fsync.c
index cf5079e..127f613 100644
--- a/drivers/usb/function/fsync.c
+++ b/drivers/usb/function/fsync.c
@@ -61,7 +61,7 @@
 static char fsync_status_tmp[32] = { 0 };
 #endif
 struct device fsync_dev;
-static void fsync_bind(struct usb_endpoint **ept, void *_ctxt);
+static int fsync_bind(struct usb_endpoint **ept, void *_ctxt);
 static void fsync_unbind(void *_ctxt);
 static void fsync_configure(int configured, void *_ctxt);
 
@@ -95,6 +95,7 @@ struct fsync_context
 };
 
 static struct fsync_context _context;
+static int cleanup;
 
 static struct usb_function usb_func_fsync = {
 	.bind = fsync_bind,
@@ -502,30 +503,36 @@ static void fsync_unbind(void *_ctxt)
 	struct fsync_context *ctxt = _ctxt;
 	struct usb_request *req;
 
-	printk(KERN_INFO "%s()\n", __func__);
-
+	if (ctxt->read_req) {
+		usb_ept_free_req(ctxt->out, ctxt->read_req);
+	}
 	while ((req = req_get(ctxt, &ctxt->rx_idle))) {
 		usb_ept_free_req(ctxt->out, req);
 	}
+	while ((req = req_get(ctxt, &ctxt->rx_done))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
 	while ((req = req_get(ctxt, &ctxt->tx_idle))) {
 		usb_ept_free_req(ctxt->in, req);
 	}
-	if (ctxt->registered)	{
+
 #ifdef USB_FSYNC_ADD_ATTR_FILE
-		device_remove_file(&fsync_dev, &dev_attr_fsync_status);
+	device_remove_file(&fsync_dev, &dev_attr_fsync_status);
 #endif
-		device_unregister(&fsync_dev);
-		ctxt->registered = 0;
-	}
+	device_unregister(&fsync_dev);
 
 	ctxt->online = 0;
 	ctxt->error = 1;
 
 	/* readers may be blocked waiting for us to go online */
 	wake_up(&ctxt->read_wq);
+	wake_up(&ctxt->write_wq);
+
+	misc_deregister(&fsync_device);
+	misc_deregister(&fsync_enable_device);
 }
 
-static void fsync_bind(struct usb_endpoint **ept, void *_ctxt)
+static int fsync_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct fsync_context *ctxt = _ctxt;
 	struct usb_request *req;
@@ -537,7 +544,6 @@ static void fsync_bind(struct usb_endpoint **ept, void *_ctxt)
 	ctxt->out = ept[0];
 	ctxt->in = ept[1];
 	ctxt->registered = 0;
-	printk(KERN_INFO "%s() %p, %p\n", __func__, ctxt->out, ctxt->in);
 
 #ifndef ALLOCATE_16K_BUFF
 	for (n = 0; n < RX_REQ_MAX; n++) {
@@ -546,7 +552,7 @@ static void fsync_bind(struct usb_endpoint **ept, void *_ctxt)
 #endif
 
 		req = usb_ept_alloc_req(ctxt->out, TXN_MAX);
-		if (req == 0) goto fail;
+		if (req == 0) goto rx_idle_fail;
 		req->context = ctxt;
 		req->complete = fsync_complete_out;
 		req_put(ctxt, &ctxt->rx_idle, req);
@@ -559,23 +565,16 @@ static void fsync_bind(struct usb_endpoint **ept, void *_ctxt)
 	{
 #endif
 		req = usb_ept_alloc_req(ctxt->in, TXN_MAX);
-		if (req == 0) goto fail;
+		if (req == 0) goto tx_idle_fail;
 		req->context = ctxt;
 		req->complete = fsync_complete_in;
 		req_put(ctxt, &ctxt->tx_idle, req);
 	}
 
-#ifndef ALLOCATE_16K_BUFF
-	printk(KERN_INFO
-	       "%s() allocated %d rx and %d tx requests\n",
-	       __func__, RX_REQ_MAX, TX_REQ_MAX);
-#else
-	printk(KERN_INFO
-		"%s(): allocated buffer: %d\n", __func__, TXN_MAX);
-#endif
-
-	misc_register(&fsync_device);
-	misc_register(&fsync_enable_device);
+	if (misc_register(&fsync_device))
+		goto misc_register_1_fail;
+	if (misc_register(&fsync_enable_device))
+		goto misc_register_2_fail;
 	
 	fsync_dev.release = fsync_dev_release;
 	fsync_dev.parent = &ctxt->pdev->dev;
@@ -584,23 +583,47 @@ static void fsync_bind(struct usb_endpoint **ept, void *_ctxt)
 	ret = device_register(&fsync_dev);
 	if (ret != 0) {
 		printk(KERN_WARNING "fsync_dev failed to register device: %d\n", ret);
-		goto fail;
+		goto device_register_fail;
 	}
 #ifdef USB_FSYNC_ADD_ATTR_FILE
 	ret = device_create_file(&fsync_dev, &dev_attr_fsync_status);
 	if (ret != 0) {
 		printk(KERN_WARNING "fsync_dev device_create_file failed: %d\n", ret);
-		device_unregister(&fsync_dev);
-		goto fail;
+		goto device_create_file_fail;
 	}
 #endif
 	ctxt->registered = 1;
 
-	return;
+#ifndef ALLOCATE_16K_BUFF
+	printk(KERN_INFO
+	       "%s() allocated %d rx and %d tx requests\n",
+	       __func__, RX_REQ_MAX, TX_REQ_MAX);
+#else
+	printk(KERN_INFO
+		"%s(): allocated buffer: %d\n", __func__, TXN_MAX);
+#endif
+	cleanup = 1;
+	return 0;
 
-fail:
-	printk(KERN_ERR "%s() could not allocate requests\n", __func__);
-	fsync_unbind(ctxt);
+#ifdef USB_FSYNC_ADD_ATTR_FILE
+device_create_file_fail:
+	device_unregister(&fsync_dev);
+#endif
+device_register_fail:
+	misc_deregister(&fsync_enable_device);
+misc_register_2_fail:
+	misc_deregister(&fsync_device);
+misc_register_1_fail:
+tx_idle_fail:
+	while ((req = req_get(ctxt, &ctxt->tx_idle))) {
+		usb_ept_free_req(ctxt->in, req);
+	}
+rx_idle_fail:
+	while ((req = req_get(ctxt, &ctxt->rx_idle))) {
+		usb_ept_free_req(ctxt->out, req);
+	}
+	printk(KERN_ERR "%s() failed\n", __func__);
+	return -1;
 }
 
 static void fsync_configure(int configured, void *_ctxt)
@@ -634,7 +657,7 @@ static void fsync_configure(int configured, void *_ctxt)
 	wake_up(&ctxt->read_wq);
 }
 
-static int __init fsync_init(void)
+void fsync_init(void)
 {
 	struct fsync_context *ctxt = &_context;
 	int retval = 0;
@@ -656,23 +679,28 @@ static int __init fsync_init(void)
 	
 	retval = platform_driver_register (&fsync_driver_reg);
 	if (retval < 0)
-		return retval;
+		goto platform_driver_register_fail;
 	retval = platform_device_register (&fsync_device_reg);
 	if (retval < 0)
-		goto err_register_device_1;
-
+		goto platform_device_register_fail;
 	retval = usb_function_register(&usb_func_fsync);
-	if (retval < 0)
-		goto err_register_device_2;
-
-	return retval;
-
-err_register_device_2:
-		platform_device_unregister(&fsync_device_reg);
-err_register_device_1:
-		platform_driver_unregister(&fsync_driver_reg);
-		return retval;
+	if (retval)
+		goto usb_function_register_fail;
+	cleanup = 1;
+	return;
 
+usb_function_register_fail:
+	platform_device_unregister (&fsync_device_reg);
+platform_device_register_fail:
+	platform_driver_unregister(&fsync_driver_reg);
+platform_driver_register_fail:
+	return;
 }
 
-module_init(fsync_init);
+void fsync_exit(void)
+{
+	if (cleanup) {
+		platform_device_unregister (&fsync_device_reg);
+		platform_driver_unregister (&fsync_driver_reg);
+	}
+}
diff --git a/drivers/usb/function/loopback.c b/drivers/usb/function/loopback.c
index d7c93a3..24ff9c2 100644
--- a/drivers/usb/function/loopback.c
+++ b/drivers/usb/function/loopback.c
@@ -32,17 +32,40 @@ struct loopback_context
 
 static struct loopback_context _context;
 
-static void loopback_bind(struct usb_endpoint **ept, void *_ctxt)
+static int loopback_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct loopback_context *ctxt = _ctxt;
 
 	ctxt->out = ept[0];
 	ctxt->in = ept[1];
 
-	printk(KERN_INFO "loopback_bind() %p, %p\n", ctxt->out, ctxt->in);
+	if ((ctxt->req_out = usb_ept_alloc_req(ctxt->out, 4096)) == NULL)
+		goto req_out_fail;
+	if ((ctxt->req_in = usb_ept_alloc_req(ctxt->in, 4096)) == NULL)
+		goto req_in_fail;
+	return 0;
+
+req_in_fail:
+	usb_ept_free_req(ctxt->out, ctxt->req_out);
+req_out_fail:
+	printk(KERN_ERR "%s() failed\n", __func__);
+	return -1;
+}
+
+static void loopback_unbind(void *_ctxt)
+{
+	struct loopback_context *ctxt = _ctxt;
 
-	ctxt->req_out = usb_ept_alloc_req(ctxt->out, 4096);
-	ctxt->req_in = usb_ept_alloc_req(ctxt->in, 4096);
+	if (ctxt->req_in) {
+		usb_ept_free_req(ctxt->in, ctxt->req_in);
+		ctxt->req_in = 0;
+	}
+	if (ctxt->req_out) {
+		usb_ept_free_req(ctxt->out, ctxt->req_out);
+		ctxt->req_out = 0;
+	}
+	ctxt->in = 0;
+	ctxt->out = 0;
 }
 
 static void loopback_queue_in(struct loopback_context *ctxt, void *data, unsigned len);
@@ -104,6 +127,7 @@ static void loopback_configure(int configured, void *_ctxt)
 
 static struct usb_function usb_func_loopback = {
 	.bind = loopback_bind,
+	.unbind = loopback_unbind,
 	.configure = loopback_configure,
 
 	.name = "loopback",
@@ -119,10 +143,7 @@ static struct usb_function usb_func_loopback = {
 	.ifc_ept_type = { EPT_BULK_OUT, EPT_BULK_IN },
 };
 
-static int __init loopback_init(void)
+void loopback_init(void)
 {
-	printk(KERN_INFO "loopback_init()\n");
-	return usb_function_register(&usb_func_loopback);
+       usb_function_register(&usb_func_loopback);
 }
-
-module_init(loopback_init);
diff --git a/drivers/usb/function/mass_storage.c b/drivers/usb/function/mass_storage.c
index 4b77888..49178da 100644
--- a/drivers/usb/function/mass_storage.c
+++ b/drivers/usb/function/mass_storage.c
@@ -377,6 +377,7 @@ static void set_bulk_out_req_length(struct fsg_dev *fsg,
 }
 
 static struct fsg_dev			*the_fsg;
+static int cleanup;
 
 static void	close_backing_file(struct fsg_dev *fsg, struct lun *curlun);
 static void	close_all_backing_files(struct fsg_dev *fsg);
@@ -2577,13 +2578,12 @@ static void lun_release(struct device *dev)
 	kref_put(&fsg->ref, fsg_release);
 }
 
-static void /* __init_or_exit */ fsg_unbind(void *_ctxt)
+static void fsg_unbind(void *_ctxt)
 {
 	struct fsg_dev		*fsg = _ctxt;
 	int			i;
 	struct lun		*curlun;
 
-	DBG(fsg, "unbind\n");
 	clear_bit(REGISTERED, &fsg->atomic_bitflags);
 
 	/* Unregister the sysfs attribute files and the LUNs */
@@ -2610,7 +2610,7 @@ static void /* __init_or_exit */ fsg_unbind(void *_ctxt)
 		kfree(fsg->buffhds[i].buf);
 }
 
-static void fsg_bind(struct usb_endpoint **ept, void *_ctxt)
+static int fsg_bind(struct usb_endpoint **ept, void *_ctxt)
 {
 	struct fsg_dev		*fsg = the_fsg;
 	int			rc;
@@ -2630,7 +2630,7 @@ static void fsg_bind(struct usb_endpoint **ept, void *_ctxt)
 	if (i > MAX_LUNS) {
 		ERROR(fsg, "invalid number of LUNs: %d\n", i);
 		rc = -EINVAL;
-		goto out;
+		goto bad_lun_count_fail;
 	}
 
 	/* Create the LUNs, open their backing files, and register the
@@ -2638,7 +2638,7 @@ static void fsg_bind(struct usb_endpoint **ept, void *_ctxt)
 	fsg->luns = kzalloc(i * sizeof(struct lun), GFP_KERNEL);
 	if (!fsg->luns) {
 		rc = -ENOMEM;
-		goto out;
+		goto lun_alloc_fail;
 	}
 	fsg->nluns = i;
 
@@ -2654,13 +2654,13 @@ static void fsg_bind(struct usb_endpoint **ept, void *_ctxt)
 		rc = device_register(&curlun->dev);
 		if (rc != 0) {
 			INFO(fsg, "failed to register LUN%d: %d\n", i, rc);
-			goto out;
+			goto luns_init_fail;
 		}
 		rc = device_create_file(&curlun->dev, &dev_attr_file);
 		if (rc != 0) {
 			ERROR(fsg, "device_create_file failed: %d\n", rc);
 			device_unregister(&curlun->dev);
-			goto out;
+			goto luns_init_fail;
 		}
 		curlun->registered = 1;
 		kref_get(&fsg->ref);
@@ -2677,7 +2677,7 @@ static void fsg_bind(struct usb_endpoint **ept, void *_ctxt)
 		 * interrupt-in) endpoint. */
 		bh->buf = kmalloc(fsg->buf_size, GFP_KERNEL);
 		if (!bh->buf)
-			goto out;
+			goto buf_alloc_fail;
 		bh->next = bh + 1;
 	}
 	fsg->buffhds[NUM_BUFFERS - 1].next = &fsg->buffhds[0];
@@ -2687,7 +2687,7 @@ static void fsg_bind(struct usb_endpoint **ept, void *_ctxt)
 	if (IS_ERR(fsg->thread_task)) {
 		rc = PTR_ERR(fsg->thread_task);
 		ERROR(fsg, "kthread_create failed: %d\n", rc);
-		goto out;
+		goto kthread_create_fail;
 	}
 
 	INFO(fsg, "Number of LUNs=%d\n", fsg->nluns);
@@ -2708,17 +2708,31 @@ static void fsg_bind(struct usb_endpoint **ept, void *_ctxt)
 		}
 	}
 	kfree(pathbuf);
-
 	set_bit(REGISTERED, &fsg->atomic_bitflags);
 
 	/* Tell the thread to start working */
 	wake_up_process(fsg->thread_task);
-	return;
+	return 0;
 
-out:
-	fsg->state = FSG_STATE_TERMINATED;	/* The thread is dead */
-	fsg_unbind(fsg);
-	close_all_backing_files(fsg);
+
+kthread_create_fail:
+buf_alloc_fail:
+	for (i = 0; i < NUM_BUFFERS; ++i)
+		if (fsg->buffhds[i].buf)
+			kfree(fsg->buffhds[i].buf);
+luns_init_fail:
+	for (i = 0; i < fsg->nluns; ++i) {
+		curlun = &fsg->luns[i];
+		if (curlun->registered) {
+			device_remove_file(&curlun->dev, &dev_attr_file);
+			device_unregister(&curlun->dev);
+			curlun->registered = 0;
+		}
+	}
+lun_alloc_fail:
+bad_lun_count_fail:
+	printk(KERN_ERR "%s() failed\n", __func__);
+	return -1;
 }
 
 static void fsg_configure(int configured, void *_ctxt)
@@ -2730,7 +2744,7 @@ static void fsg_configure(int configured, void *_ctxt)
 
 /*-------------------------------------------------------------------------*/
 
-static struct usb_function		fsg_function = {
+static struct usb_function		usb_func_fsg = {
 	.bind		= fsg_bind,
 	.unbind		= fsg_unbind,
 	.configure  = fsg_configure,
@@ -2754,7 +2768,7 @@ static struct usb_function		fsg_function = {
 };
 
 
-static int __init fsg_alloc(void)
+static int fsg_alloc(void)
 {
 	struct fsg_dev		*fsg;
 
@@ -2781,6 +2795,15 @@ static ssize_t print_switch_state(struct switch_dev *sdev, char *buf)
 	return sprintf(buf, "%s\n", (fsg->config ? "online" : "offline"));
 }
 
+static int fsg_remove(struct platform_device *pdev)
+{
+	device_remove_file(&the_fsg->pdev->dev, &dev_attr_mass_storage_enable);
+	switch_dev_unregister(&the_fsg->sdev);
+	kref_put(&the_fsg->ref, fsg_release);
+
+	return 0;
+}
+
 static int fsg_probe(struct platform_device *pdev)
 {
 	struct usb_mass_storage_platform_data *pdata = pdev->dev.platform_data;
@@ -2788,7 +2811,7 @@ static int fsg_probe(struct platform_device *pdev)
 
 	rc = fsg_alloc();
 	if (rc != 0)
-		return rc;
+		goto fsg_alloc_fail;
 
 	the_fsg->pdev = pdev;
 	the_fsg->sdev.name = DRIVER_NAME;
@@ -2807,33 +2830,41 @@ static int fsg_probe(struct platform_device *pdev)
 		&dev_attr_mass_storage_enable);
 	if (rc != 0) {
 		printk(KERN_WARNING "dev_attr_mass_storage_enable failed\n");
-		goto err_switch_dev_register;
+		goto device_create_file_fail;
 	}
 
 	wake_lock_init(&the_fsg->wake_lock, WAKE_LOCK_SUSPEND,
 		       "usb_mass_storage");
-	fsg_function.context = the_fsg;
-	rc = usb_function_register(&fsg_function);
+	usb_func_fsg.context = the_fsg;
+	rc = usb_function_register(&usb_func_fsg);
 	if (rc != 0)
-		goto err_usb_function_register;
-
+		goto usb_function_register_fail;
+	cleanup = 1;
 	return 0;
 
-err_usb_function_register:
+usb_function_register_fail:
+	device_remove_file(&the_fsg->pdev->dev, &dev_attr_mass_storage_enable);
+device_create_file_fail:
 	switch_dev_unregister(&the_fsg->sdev);
 err_switch_dev_register:
 	kref_put(&the_fsg->ref, fsg_release);
-
+fsg_alloc_fail:
 	return rc;
 }
 
 static struct platform_driver fsg_driver = {
 	.probe = fsg_probe,
+	.remove = fsg_remove,
 	.driver = { .name = DRIVER_NAME, },
 };
 
-static int __init fsg_init(void)
+void fsg_init(void)
+{
+	platform_driver_register(&fsg_driver);
+}
+
+void fsg_exit(void)
 {
-	return platform_driver_register(&fsg_driver);
+	if (cleanup)
+		platform_driver_unregister(&fsg_driver);
 }
-module_init(fsg_init);
